<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/4_World/Plugins/PluginBase/PluginRepairing.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.18.155069</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('db/dcf/_plugin_repairing_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">PluginRepairing.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../db/dcf/_plugin_repairing_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="keyword">class </span>PluginRepairing <span class="keyword">extends</span> <a class="code hl_class" href="../../dd/da1/class_plugin_base.html">PluginBase</a></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span>{</div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#a55bec6c497e1f071b1ff8918bf4638b0">    3</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a55bec6c497e1f071b1ff8918bf4638b0">Repair</a>(<a class="code hl_class" href="../../d5/da8/class_player_base.html">PlayerBase</a> player, <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> repair_kit, <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> item, <span class="keywordtype">float</span> specialty_weight, <span class="keywordtype">string</span> damage_zone = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">bool</span> use_kit_qty = <span class="keyword">true</span>)</div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span>    {</div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span>        <span class="keywordflow">switch</span> ( item.GetHealthLevel(damage_zone) ) </div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span>        {</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span>            <span class="keywordflow">case</span> <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#gaf34232b1663da2990725d6c6a7df08fe">STATE_PRISTINE</a>:</div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>            <span class="keywordflow">case</span> <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#ga3908fcde0f2e91545d7e3a51fab2d5d0">STATE_RUINED</a>:</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="preprocessor">#ifdef DEVELOPER</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>                <a class="code hl_function" href="../../d0/d62/group___debug.html#gaaa9351d895a1f244a26fd635c378c536">Print</a>(<span class="stringliteral">&quot;PluginRepairing - repairing from GameConstants.STATE_RUINED&quot;</span>);</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>                <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a2156e2f5bc387dfb83973409656de928">CalculateHealth</a>( player, repair_kit, item, specialty_weight, damage_zone, use_kit_qty );</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>            <span class="keywordflow">case</span> <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#ga9f42d331e1d7c4d096cf17f05e8266dc">STATE_WORN</a>:</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>                <span class="keywordflow">if</span>( <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#aaeed022b709f6010d5fdb465ea8ae74c">CanRepairToPristine</a>( player ) || <a class="code hl_function" href="../../dd/d93/_object_8c.html#a9e66fb2ad7dc3c93e2dc47561946bb8c">CanBeRepairedToPristine</a>( item ) )</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>                {</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>                    <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a2156e2f5bc387dfb83973409656de928">CalculateHealth</a>( player, repair_kit, item, specialty_weight,<span class="comment">/* GameConstants.DAMAGE_PRISTINE_VALUE,*/</span> damage_zone, use_kit_qty );</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>                }</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>            <span class="keywordflow">default</span>:</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>                <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a2156e2f5bc387dfb83973409656de928">CalculateHealth</a>( player, repair_kit, item, specialty_weight, damage_zone, use_kit_qty );</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        }</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>    }</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#a2156e2f5bc387dfb83973409656de928">   29</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a2156e2f5bc387dfb83973409656de928">CalculateHealth</a>( <a class="code hl_class" href="../../d5/da8/class_player_base.html">PlayerBase</a> player, <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> kit, <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> item, <span class="keywordtype">float</span> specialty_weight, <span class="keywordtype">string</span> damage_zone = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">bool</span> use_kit_qty = <span class="keyword">true</span> )</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    {</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>        <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> entity;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>        <a class="code hl_class" href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a>.<a class="code hl_function" href="../../d5/d78/group___enforce.html#ga253ceb932745ea74ca4a4d3d9e8c12d7">CastTo</a>(entity,item);</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>        </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        <span class="keywordflow">if</span> (entity != null)</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>        {</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>            <span class="comment">//Print(&quot;&quot; + item + &quot; - damage allowed&quot;);</span></div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>            entity.SetAllowDamage(<span class="keyword">true</span>);</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        }</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        </div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>        <span class="keywordtype">bool</span> kit_has_quantity = kit.HasQuantity();</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <span class="keywordtype">int</span> health_levels_count = item.GetNumberOfHealthLevels(damage_zone);</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        <span class="keywordtype">float</span> cur_kit_quantity = kit.GetQuantity();</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        <span class="keywordtype">float</span> kit_repair_cost_per_level = <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a17c9562ca5d081f6c4148834ae5788a4">GetKitRepairCost</a>( kit, item );</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        <span class="keywordtype">float</span> kit_repair_cost_adjusted; <span class="comment">//used with specialty_weight, disconnected</span></div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        <span class="keywordtype">float</span> new_quantity;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        <span class="keywordtype">int</span> target_level = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga939cca08ae6c7facc9293f2dbce3def5">Clamp</a>(item.GetHealthLevel(damage_zone) - 1, 0, health_levels_count - 1);</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>        <span class="keywordtype">float</span> health_coef;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        <span class="keywordflow">if</span> ( !<a class="code hl_function" href="../../dd/da1/class_plugin_base.html#aaeed022b709f6010d5fdb465ea8ae74c">CanRepairToPristine</a>( player ) &amp;&amp; !<a class="code hl_function" href="../../dd/d93/_object_8c.html#a9e66fb2ad7dc3c93e2dc47561946bb8c">CanBeRepairedToPristine</a>( item ) )</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        {</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>            target_level = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga939cca08ae6c7facc9293f2dbce3def5">Clamp</a>(target_level, <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#ga9f42d331e1d7c4d096cf17f05e8266dc">STATE_WORN</a>, health_levels_count - 1);</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        }</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        health_coef = item.GetHealthLevelValue(target_level,damage_zone);</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        <span class="comment">//handles kit depletion; TODO: move to separate method.</span></div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <span class="keywordflow">if</span> ( cur_kit_quantity &gt; kit_repair_cost_per_level )</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        {</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>            kit_repair_cost_adjusted = kit_repair_cost_per_level; <span class="comment">//TODO: removed speciality weight for now, it should affect speed only (?).</span></div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>            <span class="comment">//kit_repair_cost_adjusted = player.GetSoftSkillsManager().SubtractSpecialtyBonus( kit_repair_cost_per_level, specialty_weight );</span></div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>            kit_repair_cost_adjusted = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga939cca08ae6c7facc9293f2dbce3def5">Clamp</a>( kit_repair_cost_adjusted, 0, 100 );</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>            <span class="keywordflow">if</span>(use_kit_qty)</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>            {</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>                new_quantity = kit.GetQuantity() - kit_repair_cost_adjusted;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>                kit.SetQuantity( new_quantity );</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>            }</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        }</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!kit_has_quantity) <span class="comment">//&quot;kit&quot; without quantity (hammers and such) for your every day repairing needs</span></div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        {</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        {</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>            <span class="keywordflow">if</span>(use_kit_qty)</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>            {</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>                kit.SetQuantity( 0 );</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>            }</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        }</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        </div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        <span class="keywordflow">if</span> (item.GetHealth01(damage_zone,<span class="stringliteral">&quot;Health&quot;</span>) &lt; health_coef)</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        {</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>            item.SetHealth01(damage_zone,<span class="stringliteral">&quot;Health&quot;</span>,health_coef);</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        }</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        <span class="keywordflow">if</span> (entity != null)</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        {</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>            entity.ProcessInvulnerabilityCheck(entity.GetInvulnerabilityTypeString());</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        }</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>    }</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#a5025738231329c47355307aef3880415">   89</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a5025738231329c47355307aef3880415">CanRepair</a>( <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> repair_kit, <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> item, <span class="keywordtype">string</span> damage_zone = <span class="stringliteral">&quot;&quot;</span> )</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    {</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <span class="keywordtype">int</span> state = item.GetHealthLevel(damage_zone);</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        </div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>        <span class="keywordflow">if</span> ( state != <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#ga3908fcde0f2e91545d7e3a51fab2d5d0">STATE_RUINED</a> &amp;&amp; (item.CanBeRepairedToPristine() &amp;&amp; state &gt;= <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#ga9f42d331e1d7c4d096cf17f05e8266dc">STATE_WORN</a>) || (!item.CanBeRepairedToPristine() &amp;&amp; state &gt;= <a class="code hl_class" href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a>.<a class="code hl_variable" href="../../de/db5/group___item_health.html#gad901009f01e8ccc389658079d68a27f3">STATE_DAMAGED</a> ) )</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        {</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>            <span class="keywordtype">int</span> repair_kit_type = repair_kit.ConfigGetInt( <span class="stringliteral">&quot;repairKitType&quot;</span> );</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>            </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>            ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a> repairable_with_types = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a>;</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>            item.ConfigGetIntArray( <span class="stringliteral">&quot;repairableWithKits&quot;</span>, repairable_with_types );  </div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>            </div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>            <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; repairable_with_types.Count(); i++ )</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>            {</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>                <span class="keywordtype">int</span> repairable_with_type = repairable_with_types.Get(i);</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>                </div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>                <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a83dfa8e16341e19aa911272cc8165c09">IsRepairValid</a>( repair_kit_type, repairable_with_type ) )</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>                {</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>                }</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>            }</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        }</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    }</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>    </div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#a83dfa8e16341e19aa911272cc8165c09">  114</a></span>    <span class="keyword">private</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a83dfa8e16341e19aa911272cc8165c09">IsRepairValid</a>(<span class="keywordtype">int</span> repair_kit_type, <span class="keywordtype">int</span> repairable_with_type)</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    {</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>        <span class="keywordflow">if</span> ( repair_kit_type &gt; 0 &amp;&amp; repairable_with_type &gt; 0 )</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        {</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>            <span class="keywordflow">if</span> ( repair_kit_type == repairable_with_type )</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>            {</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>            }</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        }</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        </div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>    }</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span> </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#aaeed022b709f6010d5fdb465ea8ae74c">  128</a></span>    <span class="keyword">private</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#aaeed022b709f6010d5fdb465ea8ae74c">CanRepairToPristine</a>( <a class="code hl_class" href="../../d5/da8/class_player_base.html">PlayerBase</a> player )</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    {</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span><span class="comment">// temporary disabled</span></div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span><span class="comment">/*</span></div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span><span class="comment">        float specialty = player.GetStatSpecialty().Get();</span></div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span><span class="comment">        </span></div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span><span class="comment">        if ( specialty &lt;= -0.5 || specialty &gt;= 0.5 )</span></div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span><span class="comment">        {</span></div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span><span class="comment">            return true;</span></div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span><span class="comment">        }</span></div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span><span class="comment">        else</span></div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span><span class="comment">        {</span></div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span><span class="comment">            return false; </span></div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span><span class="comment">        }</span></div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span><span class="comment">*/</span></div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>; </div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>    }</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>    </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#a58bf0c7598fc0be785d0bb338673a3e4">  147</a></span>    <span class="keyword">private</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a58bf0c7598fc0be785d0bb338673a3e4">CanBeRepairedToPristine</a>( <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> item )</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>    {</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>        <span class="keywordflow">return</span> item.CanBeRepairedToPristine();</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>    }</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>    </div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno"><a class="line" href="../../dd/da1/class_plugin_base.html#a17c9562ca5d081f6c4148834ae5788a4">  152</a></span>    <span class="keyword">private</span> <span class="keywordtype">float</span> <a class="code hl_function" href="../../dd/da1/class_plugin_base.html#a17c9562ca5d081f6c4148834ae5788a4">GetKitRepairCost</a>( <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> repair_kit, <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> item )</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>    {</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a> repair_kit_types = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a>;   </div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;float&gt;</a> repair_kit_costs = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;float&gt;</a>;   </div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        </div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        item.ConfigGetIntArray( <span class="stringliteral">&quot;repairableWithKits&quot;</span>, repair_kit_types );</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        item.ConfigGetFloatArray( <span class="stringliteral">&quot;repairCosts&quot;</span>, repair_kit_costs );</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        </div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        <span class="keywordtype">int</span> eligible_kit;</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>        <span class="keywordtype">int</span> kit_in_hands = repair_kit.ConfigGetInt( <span class="stringliteral">&quot;repairKitType&quot;</span> );</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        </div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; repair_kit_types.Count(); i++ )</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        {</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>            eligible_kit = repair_kit_types.Get(i);</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>            </div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>            <span class="keywordflow">if</span> ( eligible_kit == kit_in_hands )</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>            {</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                <span class="keywordtype">float</span> repair_cost = repair_kit_costs.Get(i);</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>            }</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        } </div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>                    </div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>        <span class="keywordflow">return</span> repair_cost;</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>    }</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>}</div>
<div class="ttc" id="a_object_8c_html_a9e66fb2ad7dc3c93e2dc47561946bb8c"><div class="ttname"><a href="../../dd/d93/_object_8c.html#a9e66fb2ad7dc3c93e2dc47561946bb8c">CanBeRepairedToPristine</a></div><div class="ttdeci">bool CanBeRepairedToPristine()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d93/_object_8c_source.html#l01129">Object.c:1129</a></div></div>
<div class="ttc" id="aclass_entity_a_i_html"><div class="ttname"><a href="../../df/df9/class_entity_a_i.html">EntityAI</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d45/3___game_2_entities_2_building_8c_source.html#l00001">Building.c:2</a></div></div>
<div class="ttc" id="aclass_item_base_html"><div class="ttname"><a href="../../de/d7a/class_item_base.html">ItemBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d82/4___world_2_entities_2_core_2_inherited_2_inventory_item_8c_source.html#l00516">InventoryItem.c:517</a></div></div>
<div class="ttc" id="aclass_object_html"><div class="ttname"><a href="../../d8/d83/class_object.html">Object</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d68/_object_typed_8c_source.html#l00001">ObjectTyped.c:2</a></div></div>
<div class="ttc" id="aclass_player_base_html"><div class="ttname"><a href="../../d5/da8/class_player_base.html">PlayerBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d23/_player_base_client_8c_source.html#l00001">PlayerBaseClient.c:2</a></div></div>
<div class="ttc" id="aclass_plugin_base_html"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html">PluginBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d1/dbd/_plugin_base_8c_source.html#l00001">PluginBase.c:2</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_a17c9562ca5d081f6c4148834ae5788a4"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#a17c9562ca5d081f6c4148834ae5788a4">PluginBase::GetKitRepairCost</a></div><div class="ttdeci">private float GetKitRepairCost(ItemBase repair_kit, Object item)</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00152">PluginRepairing.c:152</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_a2156e2f5bc387dfb83973409656de928"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#a2156e2f5bc387dfb83973409656de928">PluginBase::CalculateHealth</a></div><div class="ttdeci">void CalculateHealth(PlayerBase player, ItemBase kit, Object item, float specialty_weight, string damage_zone=&quot;&quot;, bool use_kit_qty=true)</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00029">PluginRepairing.c:29</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_a5025738231329c47355307aef3880415"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#a5025738231329c47355307aef3880415">PluginBase::CanRepair</a></div><div class="ttdeci">bool CanRepair(ItemBase repair_kit, Object item, string damage_zone=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00089">PluginRepairing.c:89</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_a55bec6c497e1f071b1ff8918bf4638b0"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#a55bec6c497e1f071b1ff8918bf4638b0">PluginBase::Repair</a></div><div class="ttdeci">bool Repair(PlayerBase player, ItemBase repair_kit, Object item, float specialty_weight, string damage_zone=&quot;&quot;, bool use_kit_qty=true)</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00003">PluginRepairing.c:3</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_a58bf0c7598fc0be785d0bb338673a3e4"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#a58bf0c7598fc0be785d0bb338673a3e4">PluginBase::CanBeRepairedToPristine</a></div><div class="ttdeci">private bool CanBeRepairedToPristine(Object item)</div><div class="ttdoc">Item can be repaired to 100%.</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00147">PluginRepairing.c:147</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_a83dfa8e16341e19aa911272cc8165c09"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#a83dfa8e16341e19aa911272cc8165c09">PluginBase::IsRepairValid</a></div><div class="ttdeci">private bool IsRepairValid(int repair_kit_type, int repairable_with_type)</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00114">PluginRepairing.c:114</a></div></div>
<div class="ttc" id="aclass_plugin_base_html_aaeed022b709f6010d5fdb465ea8ae74c"><div class="ttname"><a href="../../dd/da1/class_plugin_base.html#aaeed022b709f6010d5fdb465ea8ae74c">PluginBase::CanRepairToPristine</a></div><div class="ttdeci">private bool CanRepairToPristine(PlayerBase player)</div><div class="ttdoc">Player can repair items to 100%; currently unused.</div><div class="ttdef"><b>Definition:</b> <a href="../../db/dcf/_plugin_repairing_8c_source.html#l00128">PluginRepairing.c:128</a></div></div>
<div class="ttc" id="aclassarray_html"><div class="ttname"><a href="../../d2/d41/classarray.html">array</a></div><div class="ttdoc">Result for an object found in CGame.IsBoxCollidingGeometryProxy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcd/_is_box_colliding_geometry_proxy_classes_8c_source.html#l00027">IsBoxCollidingGeometryProxyClasses.c:28</a></div></div>
<div class="ttc" id="agroup___debug_html_gaaa9351d895a1f244a26fd635c378c536"><div class="ttname"><a href="../../d0/d62/group___debug.html#gaaa9351d895a1f244a26fd635c378c536">Print</a></div><div class="ttdeci">proto void Print(void var)</div><div class="ttdoc">Prints content of variable to console/log.</div></div>
<div class="ttc" id="agroup___emote_i_ds_html_da/d45/class_game_constants"><div class="ttname"><a href="../../d2/d68/group___emote_i_ds.html#da/d45/class_game_constants">GameConstants</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/ddc/3___game_2constants_8c_source.html#l00569">constants.c:570</a></div></div>
<div class="ttc" id="agroup___enforce_html_d4/d14/class_class"><div class="ttname"><a href="../../d5/d78/group___enforce.html#d4/d14/class_class">Class</a></div><div class="ttdoc">Super root of all classes in Enforce script.</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/d15/_en_script_8c_source.html#l00010">EnScript.c:11</a></div></div>
<div class="ttc" id="agroup___enforce_html_ga253ceb932745ea74ca4a4d3d9e8c12d7"><div class="ttname"><a href="../../d5/d78/group___enforce.html#ga253ceb932745ea74ca4a4d3d9e8c12d7">Class::CastTo</a></div><div class="ttdeci">static proto bool CastTo(out Class to, Class from)</div><div class="ttdoc">Try to safely down-cast base class to child class.</div></div>
<div class="ttc" id="agroup___item_health_html_ga3908fcde0f2e91545d7e3a51fab2d5d0"><div class="ttname"><a href="../../de/db5/group___item_health.html#ga3908fcde0f2e91545d7e3a51fab2d5d0">GameConstants::STATE_RUINED</a></div><div class="ttdeci">const int STATE_RUINED</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/ddc/3___game_2constants_8c_source.html#l00713">constants.c:713</a></div></div>
<div class="ttc" id="agroup___item_health_html_ga9f42d331e1d7c4d096cf17f05e8266dc"><div class="ttname"><a href="../../de/db5/group___item_health.html#ga9f42d331e1d7c4d096cf17f05e8266dc">GameConstants::STATE_WORN</a></div><div class="ttdeci">const int STATE_WORN</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/ddc/3___game_2constants_8c_source.html#l00716">constants.c:716</a></div></div>
<div class="ttc" id="agroup___item_health_html_gad901009f01e8ccc389658079d68a27f3"><div class="ttname"><a href="../../de/db5/group___item_health.html#gad901009f01e8ccc389658079d68a27f3">GameConstants::STATE_DAMAGED</a></div><div class="ttdeci">const int STATE_DAMAGED</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/ddc/3___game_2constants_8c_source.html#l00715">constants.c:715</a></div></div>
<div class="ttc" id="agroup___item_health_html_gaf34232b1663da2990725d6c6a7df08fe"><div class="ttname"><a href="../../de/db5/group___item_health.html#gaf34232b1663da2990725d6c6a7df08fe">GameConstants::STATE_PRISTINE</a></div><div class="ttdeci">const int STATE_PRISTINE</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/ddc/3___game_2constants_8c_source.html#l00717">constants.c:717</a></div></div>
<div class="ttc" id="agroup___math_html_d4/d34/class_math"><div class="ttname"><a href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d34/_en_math_8c_source.html#l00006">EnMath.c:7</a></div></div>
<div class="ttc" id="agroup___math_html_ga939cca08ae6c7facc9293f2dbce3def5"><div class="ttname"><a href="../../d5/d98/group___math.html#ga939cca08ae6c7facc9293f2dbce3def5">Math::Clamp</a></div><div class="ttdeci">static proto float Clamp(float value, float min, float max)</div><div class="ttdoc">Clamps 'value' to 'min' if it is lower than 'min', or to 'max' if it is higher than 'max'.</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_2e5c1ab951ac691cd4fc8c5e713c6c8a.html">4_World</a></li><li class="navelem"><a class="el" href="../../dir_2b66b8ed1afe82646c8af9c779a96cad.html">Plugins</a></li><li class="navelem"><a class="el" href="../../dir_bfbe43b663634ae31e97616eeb4b3740.html">PluginBase</a></li><li class="navelem"><a class="el" href="../../db/dcf/_plugin_repairing_8c.html">PluginRepairing.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
